//
//  BasisMatrix.java
//  EVCK
//
//  Created by dario on 13/04/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

/**
 * A data structure that contains a bit matrix
*/
public class BasisMatrix {
	private int m, //expansion parameter
				n;	//shares' number
	private int[][] S;
	
	/**
	 * Create a new basis matrix for the EVCS problem
	 * @param A the matrix
	*/
	public BasisMatrix(int[][] A)
	{	n = A.length;
		m = A[0].length;
		S = A;
	}
	
	/**
	 * Returns a matrix resulting from the columns permutation provided 
	 * by the p vector.
	*/
	public int[][] share(int[] p)
	{	int[][] share = new int[n][m];
		for(int i=0; i<n; i++)
		{	for(int j=0; j<p.length; j++)
			{	share[i][j]=S[i][p[j]];
			}
		}
		return share;
	}
}
