//
//  EVCK.java
//  EVCK
//
//  Created by dario on 15/04/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

import java.io.*;

/**
 * Extended Visual Cryptography Kit
*/
public class EVCK {
	
	/**
	 * Main function: handle input parameters and launch the EVC-Scheme Implementation.
	*/
	public static void main(String[] args)
	{	String simg, img1, img2;
		boolean g, r;
		g=r=false;
	
		//first input controls
		if(args.length<3)
			usageError();
		//get the essential parameters
		simg = args[0];
		img1 = args[1];
		img2 = args[2];
		//possible options provided
		if(args.length>3)
		{	if(!args[3].equals("-G"))
				usageError();
			else 
				g = true;
			if(args.length>4)
			{	if(!args[4].equals("-r"))
					usageError();
				else 
					r = true;
			}
			if(args.length>5)
				usageError();
		}
		
		EVCS kit = null;
		try
		{	kit = new EVCS(simg, img1, img2);
		}
		catch(NotCompliantSizeException e)
		{	System.out.println("Images must have the same size.");
			System.exit(1);
		}
		//ENCODING
		kit.process();
		
		//SAVING RESULTS
		String nf1 = getResultFileName(args[1]);
		String nf2 = getResultFileName(args[2]);
		kit.save(new File(nf1), new File(nf2));
		
		//if -G provided
		if(g)
		{	EVCK_GUI gui = new EVCK_GUI(kit.getShares(), r);
		}
	}
	
	/**
	 * Sends to standard error the exact software usage syntax with some informations.
	 * Force exiting.
	*/
	public static void usageError()
	{	System.err.println("Usage: EVCK secret_image innocent_image1 innocent_image2 [-G [-r]]");
		System.err.println("Options:\n\t-G:\tshow result with a Graphic Interface\n\t\t-r:\tshow secret image obtained by stacking together the two share images.");
		System.exit(1);
	}
	
	/**
	 * Generate a file name format as follows:
	 * originalName\{old_extension}U{"_share.png"}
	*/
	public static String getResultFileName(String original)
	{	int i = original.lastIndexOf('.');
		String nuova = original.substring(0,i);
		nuova = nuova.concat("_share.png");
		return nuova;	
	}
}
